
DoomFree_VariablesLoaded = false;

local DoomFreeConfig_default_ShowEndCap = false;
local DoomFreeConfig_active_ShowEndCap = false;

local DoomFreeConfig_default_PlayerX = 0;
local DoomFreeConfig_active_PlayerX = 0;
local DoomFreeConfig_default_PlayerY = 0;
local DoomFreeConfig_active_PlayerY = 0;
local DoomFreeConfig_default_TargetX = 0;
local DoomFreeConfig_active_TargetX = 0;
local DoomFreeConfig_default_TargetY = 0;
local DoomFreeConfig_active_TargetY = 0;

local tmpPSetPoint = PlayerFrame.SetPoint;
local tmpTSetPoint = TargetFrame.SetPoint;

local tmpSpellInterrupt = nil;

function DoomFree_OnLoad(self)
  
  --register events
  self:RegisterEvent("PLAYER_ENTERING_WORLD");
  self:RegisterEvent("RAID_ROSTER_UPDATE");
  self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
  
  --hooksecurefunc("PlayerFrame_SequenceFinished", DoomFree_UpdateDisplay)
end

function DoomFree_OnEvent(self, event, ...)
  
  if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
    DoomFree_Combat_Event(...);
  elseif (event == "RAID_ROSTER_UPDATE") then
    DoomFree_Group_Update();
  elseif (event == "PLAYER_ENTERING_WORLD") then
    DoomFree_Load();
  end
end 

function DoomFree_Combat_Event(...) 
  --DEFAULT_CHAT_FRAME:AddMessage("DoomFree_Combat_Event()");
  
  local timestamp, event_type, source_GUID, source_name, source_flags, dest_GUID, dest_name, dest_flags = select(1, ...);
  if ((event_type=="SPELL_INTERRUPT") and (GetUnitName("player")==source_name)) then
    local source_spellID, source_spellName, source_spellSchool, target_spellID, target_spellName, target_spellSchool = select(9, ...);
    SendChatMessage("Interrupted ["..GetSpellLink(target_spellID).."] ("..dest_name..") ", tmpSpellInterrupt);
  end
end

function DoomFree_Group_Update()
  tmpSpellInterrupt = nil;
  if (GetNumPartyMembers() ~= 0) then 
    tmpSpellInterrupt = "PARTY";
  end
  if (GetNumRaidMembers() ~= 0) then 
    tmpSpellInterrupt = "RAID";
  end
end

function DoomFree_Load()  
  --DEFAULT_CHAT_FRAME:AddMessage("DoomFree_Load()");
  
  if ( not DoomFree_VariablesLoaded ) then
    DoomFree_Initialize();
  end
  
  DoomFreeConfig_Apply();
  DoomFree_UpdateDisplay();  

end 

function DoomFree_Initialize()
  
  --DEFAULT_CHAT_FRAME:AddMessage("DoomFree_Initialize()");

  if ( not DoomFreeConfig ) then
    DoomFreeConfig = {}; 
  end
  
  if ( DoomFreeConfig.EndCap == nil ) then 
    DoomFreeConfig.EndCap = DoomFreeConfig_default_ShowEndCap; 
  end
  if ( DoomFreeConfig.PlayerX == nil ) then 
    DoomFreeConfig.PlayerX = DoomFreeConfig_default_PlayerX; 
  end
  if ( DoomFreeConfig.PlayerY == nil ) then 
    DoomFreeConfig.PlayerY = DoomFreeConfig_default_PlayerY; 
  end
  if ( DoomFreeConfig.TargetX == nil ) then 
    DoomFreeConfig.TargetX = DoomFreeConfig_default_TargetX; 
  end
  if ( DoomFreeConfig.TargetY == nil ) then 
    DoomFreeConfig.TargetY = DoomFreeConfig_default_TargetY; 
  end
  
  DoomFree_VariablesLoaded = true;
end

function DoomFreeConfig_Apply() 
  --DEFAULT_CHAT_FRAME:AddMessage("DoomFreeConfig_Apply()");
  
  DoomFreeConfig_active_ShowEndCap = DoomFreeConfig.EndCap;
  DoomFreeConfig_active_PlayerX    = DoomFreeConfig.PlayerX;
  DoomFreeConfig_active_PlayerY    = DoomFreeConfig.PlayerY;
  DoomFreeConfig_active_TargetX    = DoomFreeConfig.TargetX;
  DoomFreeConfig_active_TargetY    = DoomFreeConfig.TargetY;
end

function DoomFree_UpdateDisplay()
  ConsoleExec("cameraDistanceMax 50");
  
  if (not DoomFreeConfig_active_ShowEndCap) then
    -- hide action bar graphic when I login
    MainMenuBarLeftEndCap:Hide();
    MainMenuBarRightEndCap:Hide();
  else 
    MainMenuBarLeftEndCap:Show();
    MainMenuBarRightEndCap:Show();
  end
  
  --DEFAULT_CHAT_FRAME:AddMessage("DoomFree_UpdateDisplay()"..DoomFreeConfig_active_PlayerX..","..DoomFreeConfig_active_PlayerY);
    
  PlayerFrame.SetPoint = tmpPSetPoint;
  TargetFrame.SetPoint = tmpTSetPoint;
  
  PlayerFrame:ClearAllPoints();
  PlayerFrame:SetPoint("CENTER", UIParent, "CENTER", DoomFreeConfig_active_PlayerX, DoomFreeConfig_active_PlayerY);
  
  TargetFrame:ClearAllPoints();
  TargetFrame:SetPoint("CENTER", UIParent, "CENTER", DoomFreeConfig_active_TargetX, DoomFreeConfig_active_TargetY);  
  
  --FocusFrame:ClearAllPoints();
  --FocusFrame:SetPoint("CENTER", UIParent, "CENTER", , );
  
  if (PetFrame:IsShown()) then
    --PetFrame:ClearAllPoints();
    --PetFrame:SetPoint("CENTER", UIParent, "CENTER", , );
  end
  
  PlayerFrame.SetPoint = function() end;
  TargetFrame.SetPoint = function() end;
  
end