-- Author      : CY Nip
-- Create Date : 08/01/2011 22:58:25

local L = MyLocalization;

local DoomFreeConfig_temp_EndCap = true;
local DoomFreeConfig_temp_PlayerX = 0;
local DoomFreeConfig_temp_PlayerY = 0;
local DoomFreeConfig_temp_TargetX = 0;
local DoomFreeConfig_temp_TargetY = 0;

function DoomFreeFrameOptions_OnLoad(panel)
  panel.name = "DoomFree";
  panel.okay = function (self) DoomFreeConfigPanel_Close(); end;
  panel.cancel = function (self) DoomFreeConfigPanel_Cancel(); end;
  
  InterfaceOptions_AddCategory(panel);
  
  getglobal(panel:GetName().."_lbl_title"):SetText("DoomFree |cFF444444"..GetAddOnMetadata("DoomFree", "Version"));
  getglobal(panel:GetName().."_lbl_description"):SetText(L['description']);
  getglobal(panel:GetName().."_lbl_author"):SetText("|cFF555555By "..GetAddOnMetadata("DoomFree", "Author"));
            
  getglobal(panel:GetName().."_cbox_endcap".."Text"):SetText(L['endcap']);     
  
  getglobal(panel:GetName().."_slider_playerx"):SetMinMaxValues(-640, -100);
  getglobal(panel:GetName().."_slider_playerx"):SetValueStep(10);
  getglobal(panel:GetName().."_slider_playerx".."Low"):SetText("-640"); 
  getglobal(panel:GetName().."_slider_playerx".."High"):SetText("-100"); 
  getglobal(panel:GetName().."_slider_playerx".."Text"):SetText(L['playerx']); 
  
  getglobal(panel:GetName().."_slider_playery"):SetMinMaxValues(-100, 100);
  getglobal(panel:GetName().."_slider_playery"):SetValueStep(10);
  getglobal(panel:GetName().."_slider_playery".."Low"):SetText("-100"); 
  getglobal(panel:GetName().."_slider_playery".."High"):SetText("100"); 
  getglobal(panel:GetName().."_slider_playery".."Text"):SetText(L['playery']); 
  
  getglobal(panel:GetName().."_slider_targetx"):SetMinMaxValues(100, 640);
  getglobal(panel:GetName().."_slider_targetx"):SetValueStep(10);
  getglobal(panel:GetName().."_slider_targetx".."Low"):SetText("100"); 
  getglobal(panel:GetName().."_slider_targetx".."High"):SetText("640"); 
  getglobal(panel:GetName().."_slider_targetx".."Text"):SetText(L['targetx']); 
                                      
  getglobal(panel:GetName().."_slider_targety"):SetMinMaxValues(-100, 100);
  getglobal(panel:GetName().."_slider_targety"):SetValueStep(10);          
  getglobal(panel:GetName().."_slider_targety".."Low"):SetText("-100");    
  getglobal(panel:GetName().."_slider_targety".."High"):SetText("100");    
  getglobal(panel:GetName().."_slider_targety".."Text"):SetText(L['targety']); 

end
 
function DoomFreeFrameOptions_OnShow(panel)
  
  -- read settings from profile, and change our checkbuttons and slider to represent them
  getglobal(panel:GetName().."_cbox_endcap"):SetChecked( DoomFreeConfig.EndCap);  
  getglobal(panel:GetName().."_slider_playerx"):SetValue( DoomFreeConfig.PlayerX);
  getglobal(panel:GetName().."_slider_playery"):SetValue( DoomFreeConfig.PlayerY);
  getglobal(panel:GetName().."_slider_targetx"):SetValue( DoomFreeConfig.TargetX);
  getglobal(panel:GetName().."_slider_targety"):SetValue( DoomFreeConfig.TargetY);
  
  -- save the settings in case user cancels out of the options dialog
  DoomFreeConfig_temp_EndCap = DoomFreeConfig.EndCap;
  DoomFreeConfig_temp_PlayerX = DoomFreeConfig.PlayerX;
  DoomFreeConfig_temp_PlayerY = DoomFreeConfig.PlayerY;
  DoomFreeConfig_temp_TargetX = DoomFreeConfig.TargetX;
  DoomFreeConfig_temp_TargetY = DoomFreeConfig.TargetY;
end
  
function DoomFreeFrameOptions_OnEvent(this, ...)

  local arg1 = ...
  
  -- every time an option box is changed update the variable it represents
  if ( this:GetName() == (this:GetParent():GetName().."_cbox_endcap" ) ) then
    DoomFreeConfig.EndCap = this:GetChecked()~=nil;
  elseif ( this:GetName() == (this:GetParent():GetName().."_slider_playerx" ) ) then
    DoomFreeConfig.PlayerX = arg1;
  elseif ( this:GetName() == (this:GetParent():GetName().."_slider_playery" ) ) then
    DoomFreeConfig.PlayerY = arg1;
  elseif ( this:GetName() == (this:GetParent():GetName().."_slider_targetx" ) ) then
    DoomFreeConfig.TargetX = arg1;
  elseif ( this:GetName() == (this:GetParent():GetName().."_slider_targety" ) ) then
    DoomFreeConfig.TargetY = arg1;
  else   
    DEFAULT_CHAT_FRAME:AddMessage("DoomFreeFrameOptions_OnEvent unhandled "..this:GetName());
  end
  
  DoomFreeConfig_Apply();
  -- realtime display change for easier configuration
  DoomFree_UpdateDisplay();
end
 
function DoomFreeConfigPanel_Close()
  DoomFreeConfig_Apply();
  -- realtime display change for easier configuration
  DoomFree_UpdateDisplay();
end

function DoomFreeConfigPanel_Cancel()
  -- cancel the changes by reverting to the last temp settings stored
  DoomFreeConfig.EndCap = DoomFreeConfig_temp_EndCap;
  DoomFreeConfig.PlayerX = DoomFreeConfig_temp_PlayerX;
  DoomFreeConfig.PlayerY = DoomFreeConfig_temp_PlayerY;
  DoomFreeConfig.TargetX = DoomFreeConfig_temp_TargetX;
  DoomFreeConfig.TargetY = DoomFreeConfig_temp_TargetY;
  
  DoomFreeConfig_Apply();
  -- realtime display change for easier configuration
  DoomFree_UpdateDisplay();
end